unit functions;

interface

uses Windows, header, Math;

function rotate(org: T3DPoint; Ido, Kei: double): T3DPoint;
function rrotate(org: T3DPoint; Ido, Kei: double): T3DPoint;
function Wxyz2Vxyz(org: T3DPoint; xtheta, ytheta: double; VOffset: T3DPoint): T3DPoint;
function Vxyz2Wxyz(org: T3DPoint; xtheta, ytheta: double; VOffset: T3DPoint): T3DPoint;
function Vxyz2Pxy(org: T3DPoint; ppL, pcL: double; Lenstype: TLensType; NOffset: T2DPoint; expan2d: double): T2DPoint;
function PxyVz2Vxyz(org: T2DPoint; Vz: double; ppL, pcL: double; Lenstype: TLensType; NOffset: T2DPoint; expan2d: double): T3DPoint;

function len2d(p1, p2: T2DPoint): double;
function Pxy2Fxy(org: T2DPoint; Wwidth: integer; Wheight: integer): T2DPoint;
function Fxy2Pxy(org: T2DPoint; Wwidth: integer; Wheight: integer): T2DPoint;
function Roundoff(X: Extended): Longint;
function CheckCamera3d(cstat: TCwinStatus): T3dPoint;
function Make3d(op3d: T3dPoint; tp3d: T3dPoint; ocamstat: TCwinStatus; ncamstat: TCwinStatus; SafeArea: Double; SafeDeg: Double): T3dPoint;
function Clip2d(Ax: Integer;Ay: Integer;Bx: Integer;By: Integer;Mx: Integer;My: Integer): TPoint;

implementation



//-----------------------------------------------------------------------------
// ̉
//-----------------------------------------------------------------------------
function Make3d(op3d: T3dPoint; tp3d: T3dPoint; ocamstat: TCwinStatus; ncamstat: TCwinStatus; SafeArea: Double; SafeDeg: Double): T3dPoint;
var
  ocam,ncam,np3d : T3dPoint;
  Ax,Ay,Az,Bx,By,Bz,Wx,Wy,Wz,Vx,Vy,Vz : Double;
  a,b,c,d,f,s,theta : Double;
  sqv,tmp : double;
  ocx,ocy,ocz,onx,ony,onz : Double;


begin
  if 0=ocamstat.PCameraL then ocamstat:=ncamstat;//ŏŏ̓R

//  ocam := checkCamera3d(ocamstat);
//  ncam := checkCamera3d(ncamstat);
  ocam := ocamstat.Camera3D;
  ncam := ncamstat.Camera3D;


  if ((ocamstat.Immidiate = -1) and (ncamstat.Immidiate <>-1))
  then begin
      ncam.X := -ncam.X;
  end;
  if ((ocamstat.Immidiate <>-1) and (ncamstat.Immidiate = -1))
  then begin
      ocam.X := -ocam.X;
  end;


  Ax:=op3d.X ; Ay:=op3d.Y ; Az:=op3d.Z ;
  Bx:=ncam.X ; By:=ncam.Y ; Bz:=ncam.Z ;

  ocx:=op3d.x-ocam.x;  ocy:=op3d.y-ocam.y;  ocz:=op3d.z-ocam.z;
  onx:=op3d.x-ncam.x;  ony:=op3d.y-ncam.y;  onz:=op3d.z-ncam.z;

  sqv := (sqrt(ocx*ocx+ocy*ocy+ocz*ocz)*sqrt(onx*onx+ony*ony+onz*onz));


  if (0 = sqv)
        //px𑪂邽߂̃xNg̒O
  then begin
    result := tp3d;
    exit;
  end
  else begin
      tmp := ( ocx*onx + ocy*ony + ocz*onz )/ sqv ;
      theta := ArcCos(tmp);
    if (theta < SafeDeg)
    then begin
      result := tp3d;
      exit;
    end;
  end;


  if ocamstat.LensType = tlOrtho
  then begin
    Vx:= -ocam.X ; Vy:= -ocam.Y ; Vz:= -ocam.Z;
  end
  else begin
    Ax:=op3d.X ; Ay:=op3d.Y ; Az:=op3d.Z ;
    Vx:=op3d.X-ocam.X; Vy:=op3d.Y-ocam.Y ; Vz:=op3d.Z-ocam.Z ;
  end;

  if ncamstat.LensType = tlOrtho
  then begin
    Bx:=tp3d.X ; By:=tp3d.Y ; Bz:=tp3d.Z ; //ŝƂ͊__
    Wx:= -ncam.X ; Wy:= -ncam.Y ; Wz:= -ncam.Z;
  end
  else begin
    Wx:=tp3d.X-ncam.X ; Wy:=tp3d.Y-ncam.Y ; Wz:=tp3d.Z-ncam.Z ;
  end;


  a:=Vx*Wx + Vy*Wy + Vz*Wz ;
  b:=Vx*Vx + Vy*Vy + Vz*Vz ;
  c:=Vx*(Bx-Ax) + Vy*(By-Ay) + Vz*(Bz-Az) ;
  d:=Wx*Wx + Wy*Wy + Wz*Wz ;
  f:=Wx*(Bx-Ax) + Wy*(By-Ay) + Wz*(Bz-Az) ;

  if 0=(a*a - b*d)
  then begin
    np3d := tp3d;

  end
  else begin
    s:=(b*f - a*c) / (a*a - b*d) ;

    np3d.X:=Bx+s*(Wx) ; np3d.Y:=By+s*(Wy) ; np3d.Z:=Bz+s*(Wz);

    Ax := np3d.X-ocam.X; Ay := np3d.Y-ocam.Y; Az := np3d.Z-ocam.Z;
    Bx := np3d.X-ncam.X; By := np3d.Y-ncam.Y; Bz := np3d.Z-ncam.Z;

    sqv := (sqrt(Ax*Ax+Ay*Ay+Az*Az)*sqrt(Bx*Bx+By*By+Bz*Bz));

    if (0 = sqv) or ((s<0) and (ncamstat.LensType <> tlOrtho))
        //px𑪂邽߂̃xNg̒O
        //JnpƂ
    then begin
      np3d := tp3d;
    end
    else begin
      tmp := ( Ax*Bx + Ay*By + Az*Bz )/ sqv ;
      theta := ArcCos(tmp);
    if (sqrt(np3d.X*np3d.X + np3d.Y*np3d.Y + np3d.Z*np3d.Z) > SafeArea)
          or (theta < SafeDeg)
    then np3d :=tp3d;
  end;

end;


  Result :=np3d;

end;

//-----------------------------------------------------------------------------
// WNbsO
//-----------------------------------------------------------------------------
function Clip2d(Ax: Integer;Ay: Integer;Bx: Integer;By: Integer;Mx: Integer;My: Integer): TPoint;
var
  tmp: Double;
  P2d: T2DPoint;
begin
  P2d.X := Ax ;
  P2d.Y := Ay ;

  if (Ax < 0)
  then begin
    if (Bx < 0)
    then begin
      P2d.X := -32767; P2d.Y := -32767;
    end
    else begin
      tmp := Ax /(Ax - Bx); P2d.X := 0; P2d.Y := tmp*(By-Ay)+Ay;
    end;
  end
  else begin
    if Ax > Mx
    then begin
      if Bx > Mx
      then begin
        P2d.X := -32767; P2d.Y := -32767;
      end
      else begin
        tmp := (Ax-Mx)/(Ax-Bx); P2d.X := Mx; P2d.Y := tmp*(By-Ay)+Ay;
      end;
    end;
  end;

  Result.X := Roundoff(P2d.X);
  Result.Y := Roundoff(P2d.Y);
end;


//-----------------------------------------------------------------------------
// JXe[^XJWϊ
//-----------------------------------------------------------------------------
function CheckCamera3d(cstat: TCwinStatus): T3DPoint;
var
  tmp3d,tmp3d2,tmp3d3 :T3dPoint;

begin
  tmp3d.X := 0;
  tmp3d.Y := 0;
  tmp3d.Z := -cstat.PPlainL-cstat.PCameraL;

  tmp3d2.X := - cstat.Offset3D.X;
  tmp3d2.Y := - cstat.Offset3D.Y;
  tmp3d2.Z := - cstat.Offset3D.Z;

  tmp3d3 := Wxyz2Vxyz(tmp3d, -(cstat.Xtheta), -(cstat.Ytheta),tmp3d2);


  if 1 = cstat.Immidiate
  then begin
    Result.X :=-tmp3d3.X; Result.Y := tmp3d3.Y; Result.Z := tmp3d3.Z;
  end
  else begin
    Result := tmp3d3;
  end;
end;


//-----------------------------------------------------------------------------
// ľܓ
//-----------------------------------------------------------------------------
function Roundoff(X: Extended): Longint;
begin
  if x >= 0 then Result := Trunc(x + 0.5)
  else Result := Trunc(x - 0.5);
end;

//-----------------------------------------------------------------------------
// Qv
//-----------------------------------------------------------------------------
function len2d(p1, p2: T2DPoint): double;
var
  tmp : double;
begin
  tmp := ((p1.X - p2.X)*(p1.X - p2.X))+((p1.Y - p2.Y)*(p1.Y - p2.Y));
  Result:= sqrt (tmp);
end;

//-----------------------------------------------------------------------------
// \sNZWϊ
//-----------------------------------------------------------------------------
function Pxy2Fxy(org: T2DPoint; Wwidth: integer; Wheight: integer): T2DPoint;
var
  coreX,coreY,side : double;

begin
  coreX := Wwidth / 2;
  coreY := Wheight / 2;

  if Wwidth > Wheight then side := coreY else side := coreX;

  Result.X := coreX + org.X * side;
  Result.Y := coreY + org.Y * side;

end;
//-----------------------------------------------------------------------------
// sNZ\Wϊ
//-----------------------------------------------------------------------------
function Fxy2Pxy(org: T2DPoint; Wwidth: integer; Wheight: integer): T2DPoint;
var
  coreX,coreY,side : double;

begin
  coreX := Wwidth / 2;
  coreY := Wheight / 2;

  if Wwidth > Wheight then side := coreY else side := coreX;

  Result.X := (org.X - coreX) / side;
  Result.Y := (org.Y - coreY) / side;

end;




//-----------------------------------------------------------------------------
// ]
//-----------------------------------------------------------------------------
function rotate(org: T3DPoint; Ido, Kei: double): T3DPoint;
var
  sx, sy, sz, tz: double;
begin
  sx := org.X;
  sy := org.Y;
  sz := org.Z;
  tz       := -sx * sin(Ido) + sz * cos(Ido);
  Result.X :=  sx * cos(Ido) + sz * sin(Ido);
  Result.Y :=  sy * cos(Kei) - tz * sin(Kei);
  Result.Z :=  sy * sin(Kei) + tz * cos(Kei);
end;

//-----------------------------------------------------------------------------
// t]
//-----------------------------------------------------------------------------
function rrotate(org: T3DPoint; Ido, Kei: double): T3DPoint;
var
  rx, ry, rz, tz: double;
begin
  rx := org.X;
  ry := org.Y;
  rz := org.Z;
  tz       :=  ry * sin(-Kei) + rz * cos(-Kei);
  Result.X :=  rx * cos(-Ido) + tz * sin(-Ido);
  Result.Y :=  ry * cos(-Kei) - rz * sin(-Kei);
  Result.Z := -rx * sin(-Ido) + tz * cos(-Ido);
end;

//-----------------------------------------------------------------------------
// [hJϊ
//-----------------------------------------------------------------------------
function Wxyz2Vxyz(org: T3DPoint; xtheta, ytheta: double; VOffset: T3DPoint): T3DPoint;
var
  Vx, Vy ,Vz ,Wx, Wy, Wz, Wx0, Wy0, Wz0, tmpX, tmpY, tmpZ: double;
begin

  Wx := org.X;
  Wy := org.Y;
  Wz := org.Z;

  Wx0:= Wx-VOffset.X;
  Wy0:= Wy-VOffset.Y;
  Wz0:= Wz-VOffset.Z;

  TmpZ := Wz0 * cos(ytheta) - Wx0 * sin(ytheta);
  TmpX := Wz0 * sin(ytheta) + Wx0 * cos(ytheta);
  TmpY := Wy0;

  Vy := TmpY *cos( xtheta) - TmpZ *sin( xtheta);
  Vz := TmpY *sin( xtheta) + TmpZ *cos( xtheta); //ǂŋtɂȂĂ܂
  Vx := TmpX;


  Result.X :=  Vx;
  Result.Y :=  Vy;
  Result.Z :=  Vz;

end;

//-----------------------------------------------------------------------------
//@J[hϊ
//-----------------------------------------------------------------------------
function Vxyz2Wxyz(org: T3DPoint; xtheta, ytheta: double; VOffset: T3DPoint): T3DPoint;
var
  Vx, Vy ,Vz ,Wx, Wy, Wz, Vx0, Vy0, Vz0, tmpX, tmpY, tmpZ: double;
begin

  Vx := org.X;
  Vy := org.Y;
  Vz := org.Z;

  Vy0 := Vy * cos(-xtheta) - Vz * sin(-xtheta);
  Vz0 := Vy * sin(-xtheta) + Vz * cos(-xtheta);
  Vx0 := Vx;

  tmpZ := Vz0 *cos(-ytheta) - Vx0 *sin(-ytheta);
  tmpX := Vz0 *sin(-ytheta) + Vx0 *cos(-ytheta);
  tmpY := Vy0;

  Wx := tmpX+VOffset.X;
  Wy := tmpY+VOffset.Y;
  Wz := tmpZ+VOffset.Z;

  Result.X := Wx;
  Result.Y := Wy;
  Result.Z := Wz;

end;

//-----------------------------------------------------------------------------
// J\Wϊ
//-----------------------------------------------------------------------------
function Vxyz2Pxy(org: T3DPoint; ppL, pcL: double; Lenstype: TLensType; NOffset: T2DPoint; expan2d: double): T2DPoint;
var
  Vx, Vy, Vz, Px, Py, Px2, Py2, Px1, Py1, Px0, Py0, tmp: double;
begin

  Vx := org.X;
  Vy := org.Y;
  Vz := org.Z;
if (Vx = 0) and (Vy = 0) then
 begin

  px :=0;
  py :=0;

 end
 else begin
  tmp:=1;
//  if Lenstype=tlOrtho then tmp:=1;
  if Lenstype=tlPars then tmp:=pcL/(ppL+pcL+Vz);
  if Lenstype=tlOrtholens then tmp:=pcL/sqrt(Vx*Vx+Vy*Vy+(ppL+pcL+Vz)*(ppL+pcL+Vz));
  if Lenstype=tlEquidlens then tmp:=pcL*arctan2(sqrt(Vx*Vx+Vy*Vy),(ppL+pcL+Vz))/sqrt(Vx*Vx+Vy*Vy);

  Px0 := Vx*tmp;
  Py0 := Vy*tmp;

  tmp:=1;
//  if Lenstype=tlOrtho then tmp:=1;
  if Lenstype=tlPars then tmp:=(ppL+pcL)/pcL;
  if Lenstype=tlOrtholens then tmp:=sqrt(1+(ppL+pcL)*(ppL+pcL))/pcL;
  if Lenstype=tlEquidlens then tmp:=1/(pcL*ArcTan2(1,(ppL+pcL)));

  tmp:=1;

  Px1 := Px0*tmp;
  Py1 := Py0*tmp;

  //p[XωɂkȂ܂iuyOɂēɁj
  //tŝƂɕ₷邽߂ɕ܂
  //ۂɂ͏̂Q͊ȒPȂP̎ɂ܂Ƃ܂܂

  Px2 := Px1-NOffset.X;
  Py2 := Py1-NOffset.Y;

  Px := Px2*expan2d;
  Py := Py2*expan2d;

 end;


  Result.X := Px;
  Result.Y := Py;

end;

//-----------------------------------------------------------------------------
// \JWϊ
//-----------------------------------------------------------------------------
function PxyVz2Vxyz(org: T2DPoint; Vz: double; ppL, pcL: double; Lenstype: TLensType; NOffset: T2DPoint; expan2d: double): T3DPoint;
var
  Vx, Vy, Px, Py, Px2, Py2, Px1, Py1, Px0, Py0, tmp: double;
begin

  Px := org.X;
  Py := org.Y;

  Px2 := Px/expan2d;
  Py2 := Py/expan2d;

  Px1 := Px2+NOffset.X;
  Py1 := Py2+NOffset.Y;

  tmp:=1;
//  if Lenstype=tlOrtho then tmp:=1;
  if Lenstype=tlPars then tmp:=(ppL+pcL)/pcL;
  if Lenstype=tlOrtholens then tmp:=sqrt(1+(ppL+pcL)*(ppL+pcL))/pcL;
  if Lenstype=tlEquidlens then tmp:=1/(pcL*ArcTan2(1,(ppL+pcL)));

  tmp:=1;

  Px0 := Px1/tmp;
  Py0 := Py1/tmp;

  //p[XωɂkȂ܂iuyOɂēɁj

  if Lenstype=tlOrtho then tmp := 1;
  if Lenstype=tlPars then tmp := (Vz+pcL+ppL)/pcL;
  if Lenstype=tlOrtholens then tmp := (Vz+pcL+ppL) / sqrt( pcL*pcL-(Px0*Px0+Py0*Py0) );
  if Lenstype=tlEquidlens then tmp := ((Vz+ppL+pcL) * tan( sqrt(Px0*Px0+Py0*Py0)/pcL )) / sqrt(Px0*Px0+Py0*Py0);

  Vx := Px0*tmp;
  Vy := Py0*tmp;

  // 񎟌̍WVzʂ̎Wɕϊ܂

  Result.X := Vx;
  Result.Y := Vy;
  Result.Z := Vz;

end;



end.
